from Orientation import *

X = x = 0
Y = y = 1
Z = z = 2

def AddLoc(loc1, loc2):
	result = [loc1[i]+loc2[i] for i in range(min(len(loc1), len(loc2)))]
	return result

def SubLoc(loc1, loc2):
	return [loc1[i]-loc2[i] for i in range(min(len(loc1), len(loc2)))]

def XYZ(PSTlocation, DirMod):
	axis = {"N":Y, "S":Y, "E":X, "W":X, "U":Z, "D":Z}
	k = {"N":1, "S":-1, "E":1, "W":-1, "U":1, "D":-1}
	dirs = PSTdir[DirMod]
	
	primaryDirection = dirs[0]
	secondaryDirection = dirs[1]
	tertiaryDirection = dirs[2]

	primaryAxis = axis[primaryDirection]
	secondaryAxis = axis[secondaryDirection]
	tertiaryAxis = axis[tertiaryDirection]

	XYZlocation = [0, 0, 0]
	XYZlocation[primaryAxis] = k[primaryDirection] * PSTlocation[0]
	XYZlocation[secondaryAxis] = k[secondaryDirection] * PSTlocation[1]
	XYZlocation[tertiaryAxis] = k[tertiaryDirection] * PSTlocation[2]


	return XYZlocation

def PST(XYZlocation, DirMod):
	axis = {"N":Y, "S":Y, "E":X, "W":X, "U":Z, "D":Z}
	k = {"N":1, "S":-1, "E":1, "W":-1, "U":1, "D":-1}

	PSTloc = [0,0,0]

	pst = PSTdir[DirMod]
	p = pst[0]
	s = pst[1]
	t = pst[2]

	pAxis = axis[p]
	sAxis = axis[s]
	tAxis = axis[t]

	PSTloc[0] = k[p] * XYZlocation[axis[p]]
	PSTloc[1] = k[s] * XYZlocation[axis[s]]
	PSTloc[2] = k[t] * XYZlocation[axis[t]]

	return PSTloc

def test():
	print XYZ(PST([1,2,3], "NU"), "NU")
	print AddLoc([0,10,0], XYZ([0,-10,0], "NU"))
